package fi.mikkonummelin.warproject;

import com.fasterxml.jackson.databind.ObjectMapper;
import java.io.*;
import javax.servlet.*;
import javax.servlet.annotation.*;
import javax.servlet.http.*;
import org.apache.commons.logging.*;

@WebServlet("/lomake/*")
public class LomakeServlet extends HttpServlet {

    private static final Log LOG = LogFactory.getLog(LomakeServlet.class);

    private void defaultAction(HttpServletRequest req, HttpServletResponse resp)
            throws ServletException, IOException {
        req.getRequestDispatcher("/WEB-INF/lomake.jsp").forward(req, resp);
    }

    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp)
            throws ServletException, IOException {
        String pathName = req.getPathInfo();
        LOG.info("Pathname: " + pathName);
        if (pathName == null) {
            defaultAction(req, resp);
            return;
        }
        switch (pathName) {
            case "/vastaus": {
                String nimi = req.getParameter("nimi");
                String osoite = req.getParameter("osoite");
                req.setAttribute("nimi", nimi);
                req.setAttribute("osoite", osoite);
                req.getRequestDispatcher("/WEB-INF/vastaus.jsp").forward(req, resp);
                break;
            }
            case "/ajaxvastaus": {
                LOG.info("AJAX:ia kysytty!");
                String nimi = req.getParameter("nimi");
                String osoite = req.getParameter("osoite");
                resp.setContentType("application/json");
                LOG.info("nimi="+nimi+", osoite="+osoite);
                NimiJaOsoite njo = new NimiJaOsoite(nimi, osoite);
                ObjectMapper mapper;
                mapper = new ObjectMapper();
                mapper.writeValue(resp.getOutputStream(), njo);
                break;
            }
                
            default: {
                defaultAction(req, resp);
            }
        }
    }
}
